﻿Module Module_FastTimers

    ' ===============================================================================================
    '   MULTIMEDIA TIMER   ( resolution = 1 millisec )  ( interval minumun = 2 or 3 millisec )
    '   working on every windows system
    ' ===============================================================================================
    Private Declare Function timeKillEvent Lib "winmm.dll" (ByVal uID As Int32) As Int32
    Private Declare Function timeSetEvent Lib "winmm.dll" (ByVal uDelay As Int32, _
                                                           ByVal uResolution As Int32, _
                                                           ByVal lpFunction As Timer_Elapsed_Delegate, _
                                                           ByVal dwUser As Int32, _
                                                           ByVal uFlags As Int32) As Int32

    Private Const CALLBACK_PERIODIC As Int32 = 1   ' callback function called every uDelay millisec
    Private hMMTimer As Int32
    Private SystemResolution As Integer = 0
    Private TimerDelegate As Timer_Elapsed_Delegate
    Delegate Sub Timer_Elapsed_Delegate(ByVal uID As Int32, ByVal uMsg As Int32, _
                                        ByVal dwUser As Int32, ByVal dw1 As Int32, ByVal dw2 As Int32)
    Private Sub Timer_Elapsed(ByVal uID As Int32, ByVal uMsg As Int32, _
                              ByVal dwUser As Int32, ByVal dw1 As Int32, ByVal dw2 As Int32)
        'Beep()
        ' ----------------------------------------------------- Create and write log-line
        DataLogger_Tick()
    End Sub

    Friend FastTimerMillisec As Int32

    Friend Sub FastTimer_Start()
        FastTimer_Stop()
        If hMMTimer = 0 Then
            TimerDelegate = New Timer_Elapsed_Delegate(AddressOf Timer_Elapsed)
            hMMTimer = timeSetEvent(FastTimerMillisec, 0, TimerDelegate, 0, CALLBACK_PERIODIC)
        End If
    End Sub
    Friend Sub FastTimer_Stop()
        If hMMTimer <> 0 Then
            timeKillEvent(hMMTimer)
            hMMTimer = 0
        End If
    End Sub

End Module
